package ldoce;

use 5.008;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use ldoce ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw() ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(find_word all_pos similar_def same_pos sub_codes same_subcodes quit_ldoce same_sub);

our $VERSION = '0.01';


# Preloaded methods go here.

sub find_word
{
    $input = $_[0];
    chomp($input);
    @parameter = split(/\s+-/, $input);
    $word = $parameter[0];
    
    if ($word eq "0")
    {
	last;
    }    

    $FOUND = 0;                                                   # set the FOUND flag to 0
    
    @first_alpha = split//,$word;                                 # get the first alphabet from the word entered by the user
    
    
    $path_name = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";     # set the path name
    
    
    $first_alpha[0] = uc($first_alpha[0]);                        # convert the first alphabet into uppercase
    if($first_alpha[0] eq "E")
    {
	$first_alpha[0] = "e";
	$path_name .= $first_alpha[0] . ".sgm";
    }
    
    else
    {
	$path_name .= $first_alpha[0] . ".SGM";
    }

    open(DIC,$path_name);                                         # open the corresponding alphabet file
    
    
    
    open(OUTPUT, "> WORDFILE");                                   # this part reads the file and puts entry of one word in one line
    $line = <DIC>;
    while ($line = <DIC>)
    {
	chomp($line);
	@word = split(/>/,$line);	                          # Split each line with ">" to get <Entry>	
	print(OUTPUT "$line");
	if ($word[$#word-1] eq "</Entry")
	{
	    print(OUTPUT "\n");
	}
    }
    close(OUTPUT);
    close(DIC);
    
    
    
    open (FILE, "WORDFILE");
    
    $line = <FILE>;
    
    while($line = <FILE>)
    {
	chomp($line);
	@tempa = split(/<\/HWD>/, $line);
	@tempb = split(/<HWD>/, $tempa[0]);
	if ($word eq $tempb[1])
	{
	    $FOUND = 1;
	}
    }
    close (FILE);
    if ($FOUND == 1)
    {
	$flag = 0;
	%ifprint=();
	@choice = @_;
	for($i=1;$i<=$#_;$i++)
	{
	    
	    if ($choice[$i] eq "hyp")
	    {
		$ifprint{h} = 1;
	    }
	    if ($choice[$i] eq "pron")
	    {
		$ifprint{pr} = 1;
	    }
	    if ($choice[$i] eq "freq")
	    {
		$ifprint{f} = 1;
	    }
	    if ($choice[$i] eq "pos")
	    {
		$ifprint{po} = 1;
	    }
	    if ($choice[$i] eq "inf")
	    {
		$ifprint{i} = 1;
	    }
	    if ($choice[$i] eq "sen")
	    {
		$ifprint{sen} = 1;
		
	    }
	    if ($choice[$i] eq "tail")
	    {
		$ifprint{t} = 1;
	    }
	    $flag = 1;
	}
	if($flag != 1)
	{
	     $ifprint{h} = 1;
	     $ifprint{pr} = 1;
	     $ifprint{f} = 1;
	     $ifprint{po} = 1;
	     $ifprint{sen} = 1;
	     $ifprint{t} = 1;
	     $ifprint{i} = 1;
	     print "hello";
	 }
    }
    open (FILE, "WORDFILE");
    while($line = <FILE>)
    {
	#chomp;
	@tempa = split(/<\/HWD>/, $line);
	if(exists($tempa[0]))
	{
	    @tempb = split(/<HWD>/, $tempa[0]);
	    
	    if (exists($tempb[1]) and $word eq $tempb[1])
	    {
		$FOUND = 1;
		print "\n";
		
		# Print <HOMNUM>
		
		@homnumtemp = split(/<\/HOMNUM>/, $line);
		if (exists($homnumtemp[1]) and $homnumtemp[1] ne "")
		{
		    print "\n";
		    @homnum = split(/<HOMNUM>/, $homnumtemp[0]);
				print "<HOMNUM>$homnum[1]----------------------------------------------\n";
		}
		
		# Print <HYPHENATION>
		
		@hyphenationtemp = split(/<\/HYPHENATION>/, $line);
		if (exists($hyphenationtemp[1]) and ($hyphenationtemp[1] ne "") && exists($ifprint{h}) and ($ifprint{h} eq 1))
		{
		    @hyphenation = split(/<HYPHENATION>/, $hyphenationtemp[0]);
				print "<HYPHENATION>$hyphenation[1]\n";
		}
		
		# Print <PRON>
		
		@prontemp = split(/<\/PRON>/, $line);
		if (exists($prontemp[1]) and ($prontemp[1] ne "") && exists($ifprint{pr}) and ($ifprint{pr} eq 1))
		{
		    @pron = split(/<PRON>/, $prontemp[0]);
				print "<PRON>$pron[1]\n";
		}
		
		# Print <FREQ>
		
		@freqtemp = split(/<\/FREQ>/, $line);
		if (exists($freqtemp[1]) and ($freqtemp[1] ne "") && exists($ifprint{f}) and ($ifprint{f} eq 1))
		{
		    @freq = split(/<FREQ>/, $freqtemp[0]);
				print "<FREQ>$freq[1]\n";
		}
		
		# Print <POS>
		
		@postemp = split(/<\/POS>/, $line);
		if (exists($postemp[1]) and ($postemp[1] ne "") && exists($ifprint{po}) and ($ifprint{po} eq 1))
	    		{
			    @pos = split(/<POS>/, $postemp[0]);
			    print "<POS>$pos[1]\n";
	    		}
		
		# Print <INFLECTIONS>
		
		@inflectiontemp = split(/<\/Inflections>/, $line);
		if (exists($inflectiontemp[1]) and ($inflectiontemp[1] ne "") && exists($ifprint{i}) and ($ifprint{i} eq 1))
		{
		    @inflection = split(/<Inflections>/, $inflectiontemp[0]);
				@spellingtemp = split(/<\/SPELLING>/, $inflection[1]);
		    foreach $spellingtemp ( @spellingtemp )
		    {
			print "$spellingtemp\n";
		    }
		}
		
		# Print each <Sense>
		
		if (exists($ifprint{sen}) and $ifprint{sen} eq 1)
		{
		    @sensetemp = split(/<\/Sense>/, $line);
				$i = 1;
		    foreach $sensetemp ( @sensetemp )
		    {
			if ($i <= $#sensetemp)
			{
			    print "<SENSE>--$i\n";
			    $i++;
			}
			@sense = split(/<Sense>/, $sensetemp);
			
			# Print <FIELD>
			if(exists($sense[1]))
			{
			    @fieldtemp = split(/<\/FIELD>/, $sense[1]);
			    if (exists($fieldtemp[1]) and $fieldtemp[1] ne "")
			    {
				@field = split(/<FIELD>/, $fieldtemp[0]);
				print "<FIELD>$field[1]\n";
			    }
			    
			    # Print <REFHWD>
			    
			    @gramtemp = split(/<\/REFHWD>/, $sense[1]);
			    if (exists($gramptemp[1]) and $gramtemp[1] ne "")
			    {
				@gram = split(/<REFHWD>/, $gramtemp[0]);
				print "<REFHWD>$gram[1]\n";
			    }
			    
			    # Print <REFHOMNUM>
			    
			    @refhomnumtemp = split(/<\/REFHOMNUM>/, $sense[1]);
			    if (exists($tefhomnumtemp[1]) and $refhomnumtemp[1] ne "")
			    {
				@refhomnum = split(/<REFHOMNUM>/, $refhomnumtemp[0]);
				print "<REFHOMNUM>$refhomnum[1]\n";
			    }
			    
			    # Print <REFSENSENUM>
			    
			    @refsensenumtemp = split(/<\/REFSENSENUM>/, $sense[1]);
			    if (exists($refsensenumtemp[1]) and $refsensenumtemp[1] ne "")
			    {
				@refsensenum = split(/<REFSENSENUM>/, $refsensenumtemp[0]);
				print "<REFSENSENUM>$refsensenum[1]\n";
			    }

			    # Print <GRAM>
			    
			    @gramtemp = split(/<\/GRAM>/, $sense[1]);
			    if (exists($gramtemp[1]) and $gramtemp[1] ne "")
			    {
				@gram = split(/<GRAM>/, $gramtemp[0]);
				print "<GRAM>$gram[1]\n";
			    }
			    
			    # Print <LITTLEWORDS>
			    
			    @littlewordstemp = split(/<\/LITTLEWORDS>/, $sense[1]);
			    if (exists($littlewordstemp[1]) and $littlewordstemp[1] ne "")
			    {
				@littlewords = split(/<LITTLEWORDS>/, $littlewordstemp[0]);
				print "<LITTLEWORDS>$littlewords[1]\n";
					}
			    
			    # Print <ROMAN>
			    
			    @romantemp = split(/<\/ROMAN>/, $sense[1]);
			    if (exists($romantemp[1]) and $romantemp[1] ne "")
			    {
				@roman = split(/<ROMAN>/, $romantemp[0]);
			    		print "<ROMAN>$roman[1]\n";
			    }
			    
			    # Print <LEXVAR>
			    
			    @lexvartemp = split(/<\/LEXVAR>/, $sense[1]);
			    if (exists($lexvartemp[1]) and $lexvartemp[1] ne "")
			    {
				@lexvar = split(/<LEXVAR>/, $lexvartemp[0]);
				print "<LEXVAR>$lexvar[1]\n";
			    }

			    # Print <ACTIV>
			    
			    @activtemp = split(/<\/ACTIV>/, $sense[1]);
			    if (exists($activtemp[1]) and $activtemp[1] ne "")
			    {
				@activ = split(/<ACTIV>/, $activtemp[0]);
					    print "<ACTIV>$activ[1]\n";
			    }
			    
			    # Print <DEF>
			    
			    @deftemp = split(/<\/DEF>/, $sense[1]);
			    if (exists($deftemp[1]) and $deftemp[1] ne "")
			    {
				@def = split(/<DEF>/, $deftemp[0]);
				print "<DEF>$def[1]\n";
			    }
			    
			    # Print <PROPFORM>
			    
			    @propformtemp = split(/<\/PROPFORM>/, $sense[1]);
			    if (exists($propformtemp[1]) and $propformtemp[1] ne "")
			    {
				@propform = split(/<PROPFORM>/, $propformtemp[0]);
				print "<PROPFORM>$propform[1]\n";
			    }
			    
			    # Print <COLON>
			    
			    @colontemp = split(/<\/COLON>/, $sense[1]);
			    if (exists($colontemp[1]) and $colontemp[1] ne "")
			    {
				@colon = split(/<COLON>/, $colontemp[0]);
				print "<COLON>$colon[1]\n";
			    }
			    
			    # Print <EXAMPLE>
			    
			    @exampletemp = split(/<\/EXAMPLE>/, $sense[1]);
			    if (exists($exampletemp[1]) and $exampletemp[1] ne "")
			    {
				@example = split(/<EXAMPLE>/, $exampletemp[0]);
				print "<EXAMPLE>$example[1]\n";
			    }
			}
		    }
	    	}

		# Print <Tail>
		
		if (exists($ifprint{t}) and $ifprint{t} eq 1)
		{
		    print "<Tail>---\n";
		    @tailtemp = split(/<\/Tail>/, $line);
		    @tail = split(/<Tail>/, $tailtemp[0]);
		    if(exists($tail[1]))
		    {
			@spellingtemp = split(/<\/SPELLING>/, $tail[1]);
			
			if (exists($spellingtemp[1]) and $spellingtemp[1] ne "")
			{
			    @spelling = split(/SPELLING/, $spellingtemp[0]);
			    print "<SPELLING>$spelling[1]\n";
			}
			@postemp = split(/<\/POS>/, $tail[1]);
			if (exists($postemp[1]) and $postemp[1] ne "")
			{
			    @pos = split(/<POS>/, $postemp[0]);
			    print "<POS>$pos[1]\n";
			}
		    }
		}
	    }
	}
    }
    
    if ($FOUND != 1)
    {
	print "\nWord $word not found!\n";
    }
    unlink "WORDFILE";
    return 1;
}


sub similar_def
{
    %def_hash = ();
    
    $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
	
    for($ctr = 1;$ctr<=26;$ctr++)
    {
	if($ctr == 1)
	{
	    $fn = "A.SGM";
	}
	if($ctr == 2)
	{
	    $fn = "B.SGM";
	}
	
	if($ctr == 3)
	{
	    $fn = "C.SGM";
	}
	
	if($ctr == 4)
	{
	    $fn = "D.SGM";
	}
	if($ctr == 5)
	{
	    $fn = "e.sgm";
	}
	if($ctr == 6)
	{
	    $fn = "F.SGM";
	}
	if($ctr == 7)
	{
	    $fn = "G.SGM";
	}
	if($ctr == 8)
	{
	    $fn = "H.SGM";
	}
	if($ctr == 9)
	{
	    $fn = "I.SGM";
	}
	if($ctr == 10)
	{
	    $fn = "J.SGM";
	}
	if($ctr == 11)
	{
	    $fn = "K.SGM";
	}
	if($ctr == 12)
	{
	    $fn = "L.SGM";
	}
	if($ctr == 13)
	{
	    $fn = "M.SGM";
	}
	if($ctr == 14)
	{
	    $fn = "N.SGM";
	}
	if($ctr == 15)
	{
	    $fn = "O.SGM";
	}
	if($ctr == 16)
	{
	    $fn = "P.SGM";
	}
	if($ctr == 17)
	{
	    $fn = "Q.SGM";
	}
	if($ctr == 18)
	{
	    $fn = "R.SGM";
	}
	if($ctr== 19)
	{
	    $fn = "S.SGM";
	}
	if($ctr == 20)
	{
	    $fn = "T.SGM";
	}
	if($ctr == 21)
	{
	    $fn = "U.SGM";
	}
	if($ctr == 22)
	{
	    $fn = "V.SGM";
	}
	if($ctr == 23)
	{
	    $fn = "W.SGM";
	}
	if($ctr == 24)
	{
	    $fn = "X.SGM";
	}
	if($ctr == 25)
	{
	    $fn = "Y.SGM";
	}
	if($ctr == 26)
	{
	    $fn = "Z.SGM";
	}

	$filename = $path . $fn;
	
	@arr = @_;

#	for($ctr100=0;$ctr100<=$#arr;$ctr100++)
	#{
	
#	    $input = $arr[$ctr100];
#	    chomp($input);
	
	    open(FILE,$filename);

	
	    
#	    @word = ();
#	    @word=split(/ /,$input);
#	    print "Hello @word\n";
	while($line = <FILE>)
	{
	    chomp($line);
	    @tempa = split(/<\/HWD>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<HWD>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    $spelling = $tempb[1];
		}
	    }
	    @tempd = split(/<\/POS>/, $line);
	    if (exists($tempd[0]))
	    {
		@tempe = split(/<POS>/, $tempd[0]);
		if (exists($tempe[1]))
		{
		    @tempf = split(/</, $tempe[1]);
		}
	    }
	    @tempa = split(/<\/DEF>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<DEF>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    @tempc = split(/</, $tempb[1]);
		    if (exists($tempc[0]))
		    {
			$flag=0;
			foreach $word(@arr)
			{
			    
			    @def=split(/ $word /, $tempc[0]);
			    if (exists($def[1]) && (!($def[0] eq $tempc[0])))
			    {
				$flag = 1;
			    }
			    else
			    {
				@defa=split(/ $word/, $tempc[0]);
				if (exists($defa[0]))
				{
				    if (($defa[0] ne $tempc[0]) && (!(exists($defa[1]))))
				    {
					$flag = 1;
				    }
				}
				else
				{
				    @defb=split(/$word /, $tempc[0]);
				    if (exists($defb[0]))
				    {
					if (($defb[0] ne $tempc[0]) && (!(exists($defb[1]))))
					{
					    $flag = 1;
					}
				    }
				}
			    }
			
			    if ($flag == 1)
			    {
				$def_hash{$spelling}{$tempc[0]}++;
				$def_hash{$spelling}{$tempf[0]}++;
				# print("WORD:       $spelling\n");
				# print("DEFINITION: $tempc[0]\n");
				# print("POS:        $tempf[0]\n\n");
			    }
			}
		    }
		}
	    }
	}
	close(FILE);
    }
    
    return %def_hash;
}


sub all_pos
{
    $i=0;
    
    %pos = ();

    $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    for($ctr = 1;$ctr<=26;$ctr++)
    {
	if($ctr == 1)
	{
	    $fn = "A.SGM";
	}
	if($ctr == 2)
	{
	    $fn = "B.SGM";
	}

	if($ctr == 3)
	{
	    $fn = "C.SGM";
	}

	if($ctr == 4)
	{
	    $fn = "D.SGM";
	}
	if($ctr == 5)
	{
	    $fn = "e.sgm";
	}
	if($ctr == 6)
	{
	    $fn = "F.SGM";
	}
	if($ctr == 7)
	{
	    $fn = "G.SGM";
	}
	if($ctr == 8)
	{
	    $fn = "H.SGM";
	}
	if($ctr == 9)
	{
	    $fn = "I.SGM";
	}
	if($ctr == 10)
	{
	    $fn = "J.SGM";
	}
	if($ctr == 11)
	{
	    $fn = "K.SGM";
	}
	if($ctr == 12)
	{
	    $fn = "L.SGM";
	}
	if($ctr == 13)
	{
	    $fn = "M.SGM";
	}
	if($ctr == 14)
	{
	    $fn = "N.SGM";
	}
	if($ctr == 15)
	{
	    $fn = "O.SGM";
	}
	if($ctr == 16)
	{
	    $fn = "P.SGM";
	}
	if($ctr == 17)
	{
	    $fn = "Q.SGM";
	}
	if($ctr == 18)
	{
	    $fn = "R.SGM";
	}
	if($ctr== 19)
	{
	    $fn = "S.SGM";
	}
	if($ctr == 20)
	{
	    $fn = "T.SGM";
	}
	if($ctr == 21)
	{
	    $fn = "U.SGM";
	}
	if($ctr == 22)
	{
	    $fn = "V.SGM";
	}
	if($ctr == 23)
	{
	    $fn = "W.SGM";
	}
	if($ctr == 24)
	{
	    $fn = "X.SGM";
	}
	if($ctr == 25)
	{
	    $fn = "Y.SGM";
	}
	if($ctr == 26)
	{
	    $fn = "Z.SGM";
	}

	$filename = $path . $fn;
	
	open(FILE,"$filename");


	while($line = <FILE>)
	{
	    $exist = 0;
	    chomp($line);
	    @tempa = split(/<\/POS>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<POS>/, $tempa[0]);

		if(exists($tempb[1]))
		{
		    $pos{$tempb[1]}++;
		}

	    }
	}
	
    }     


#    foreach $record(keys %pos)
#    {
#	print "\n$record : $pos{$record}";
#    }
    return %pos;
}




sub same_pos
{
#    open (OUTFILE,">adjectives.txt");
    $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    for($ctr = 1;$ctr<=26;$ctr++)
    {
	if($ctr == 1)
	{
	    $fn = "A.SGM";
	}
	if($ctr == 2)
	{
	    $fn = "B.SGM";
	}

	if($ctr == 3)
	{
	    $fn = "C.SGM";
	}

	if($ctr == 4)
	{
	    $fn = "D.SGM";
	}
	if($ctr == 5)
	{
	    $fn = "e.sgm";
	}
	if($ctr == 6)
	{
	    $fn = "F.SGM";
	}
	if($ctr == 7)
	{
	    $fn = "G.SGM";
	}
	if($ctr == 8)
	{
	    $fn = "H.SGM";
	}
	if($ctr == 9)
	{
	    $fn = "I.SGM";
	}
	if($ctr == 10)
	{
	    $fn = "J.SGM";
	}
	if($ctr == 11)
	{
	    $fn = "K.SGM";
	}
	if($ctr == 12)
	{
	    $fn = "L.SGM";
	}
	if($ctr == 13)
	{
	    $fn = "M.SGM";
	}
	if($ctr == 14)
	{
	    $fn = "N.SGM";
	}
	if($ctr == 15)
	{
	    $fn = "O.SGM";
	}
	if($ctr == 16)
	{
	    $fn = "P.SGM";
	}
	if($ctr == 17)
	{
	    $fn = "Q.SGM";
	}
	if($ctr == 18)
	{
	    $fn = "R.SGM";
	}
	if($ctr== 19)
	{
	    $fn = "S.SGM";
	}
	if($ctr == 20)
	{
	    $fn = "T.SGM";
	}
	if($ctr == 21)
	{
	    $fn = "U.SGM";
	}
	if($ctr == 22)
	{
	    $fn = "V.SGM";
	}
	if($ctr == 23)
	{
	    $fn = "W.SGM";
	}
	if($ctr == 24)
	{
	    $fn = "X.SGM";
	}
	if($ctr == 25)
	{
	    $fn = "Y.SGM";
	}
	if($ctr == 26)
	{
	    $fn = "Z.SGM";
	}

	$filename = $path . $fn;
	@arr = @_;
	$input = $arr[0];
#	print "$input\n";
	#print "\n\n$input";
	#<STDIN>;
	#exit();
	#chomp($input);
	open(FILE,$filename);
	while($line = <FILE>)
	{
	 #   print "inside while\n";
	    chomp($line);
	    @tempa = split(/<\/HWD>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<HWD>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    $word = $tempb[1];
		}
	    }
	    @tempa = split(/<\/POS>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<POS>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    if ($input eq $tempb[1])
		    {
			#print "$word\n";
			$same_pos_hash{$word}++;
		    }
		}
	    }
	}
	
    }
    return %same_pos_hash;
}

sub sub_codes
{
    %sub_hash = ();
    $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    for($ctr = 1;$ctr<=26;$ctr++)
    {
	if($ctr == 1)
	{
	    $fn = "A.SGM";
	}
	if($ctr == 2)
	{
	    $fn = "B.SGM";
	}

	if($ctr == 3)
	{
	    $fn = "C.SGM";
	}

	if($ctr == 4)
	{
	    $fn = "D.SGM";
	}
	if($ctr == 5)
	{
	    $fn = "e.sgm";
	}
	if($ctr == 6)
	{
	    $fn = "F.SGM";
	}
	if($ctr == 7)
	{
	    $fn = "G.SGM";
	}
	if($ctr == 8)
	{
	    $fn = "H.SGM";
	}
	if($ctr == 9)
	{
	    $fn = "I.SGM";
	}
	if($ctr == 10)
	{
	    $fn = "J.SGM";
	}
	if($ctr == 11)
	{
	    $fn = "K.SGM";
	}
	if($ctr == 12)
	{
	    $fn = "L.SGM";
	}
	if($ctr == 13)
	{
	    $fn = "M.SGM";
	}
	if($ctr == 14)
	{
	    $fn = "N.SGM";
	}
	if($ctr == 15)
	{
	    $fn = "O.SGM";
	}
	if($ctr == 16)
	{
	    $fn = "P.SGM";
	}
	if($ctr == 17)
	{
	    $fn = "Q.SGM";
	}
	if($ctr == 18)
	{
	    $fn = "R.SGM";
	}
	if($ctr== 19)
	{
	    $fn = "S.SGM";
	}
	if($ctr == 20)
	{
	    $fn = "T.SGM";
	}
	if($ctr == 21)
	{
	    $fn = "U.SGM";
	}
	if($ctr == 22)
	{
	    $fn = "V.SGM";
	}
	if($ctr == 23)
	{
	    $fn = "W.SGM";
	}
	if($ctr == 24)
	{
	    $fn = "X.SGM";
	}
	if($ctr == 25)
	{
	    $fn = "Y.SGM";
	}
	if($ctr == 26)
	{
	    $fn = "Z.SGM";
	}

	$filename = $path . $fn;
	
	open(FILE,"$filename");

	$i=1;
	$exist=0;
	open(FILE,$filename);
	while($line = <FILE>)
	{
	    chomp($line);
	    @tempa = split(/<\/FIELD>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<FIELD>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    $sub_hash{$tempb[1]}++
			#for ($j=1; $j<=$#field; $j++)
			#{
			#	if ($field[$j] eq $tempb[1])
			#	{
			#	    $exist=1;
			#	}
			#    }
			#    if ($exist==0)
			#    {
			#	$field[$i]=$tempb[1];
			#	$i++;
			#    }
			#    $exist=0;
		}
	    }
	}
    
    close (FILE);
    }
#    for ($i=1; $i<=$#field; $i++)
#    {
#	print("$i--$field[$i]\n");
#    }

#    foreach $record(keys %sub_hash)
#    {
#	print "\n$record : $sub_hash{$record}";
#    }
    
    return %sub_hash;
    
}


sub same_subcodes
{
    %same_hash=();
    $path = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";
    for($ctr = 1;$ctr<=26;$ctr++)
    {
	if($ctr == 1)
	{
	    $fn = "A.SGM";
	}
	if($ctr == 2)
	{
	    $fn = "B.SGM";
	}
	
	if($ctr == 3)
	{
	    $fn = "C.SGM";
	}
	
	if($ctr == 4)
	{
	    $fn = "D.SGM";
	}
	if($ctr == 5)
	{
	    $fn = "e.sgm";
	}
	if($ctr == 6)
	{
	    $fn = "F.SGM";
	}
	if($ctr == 7)
	{
	    $fn = "G.SGM";
	}
	if($ctr == 8)
	{
	    $fn = "H.SGM";
	}
	if($ctr == 9)
	{
	    $fn = "I.SGM";
	}
	if($ctr == 10)
	{
	    $fn = "J.SGM";
	}
	if($ctr == 11)
	{
	    $fn = "K.SGM";
	}
	if($ctr == 12)
	{
	    $fn = "L.SGM";
	}
	if($ctr == 13)
	{
	    $fn = "M.SGM";
	}
	if($ctr == 14)
	{
	    $fn = "N.SGM";
	}
	if($ctr == 15)
	{
	    $fn = "O.SGM";
	}
	if($ctr == 16)
	{
	    $fn = "P.SGM";
	}
	if($ctr == 17)
	{
	    $fn = "Q.SGM";
	}
	if($ctr == 18)
	{
	    $fn = "R.SGM";
	}
	if($ctr== 19)
	{
	    $fn = "S.SGM";
	}
	if($ctr == 20)
	{
	    $fn = "T.SGM";
	}
	if($ctr == 21)
	{
	    $fn = "U.SGM";
	}
	if($ctr == 22)
	{
	    $fn = "V.SGM";
	}
	if($ctr == 23)
	{
	    $fn = "W.SGM";
	}
	if($ctr == 24)
	{
	    $fn = "X.SGM";
	}
	if($ctr == 25)
	{
	    $fn = "Y.SGM";
	}
	if($ctr == 26)
	{
	    $fn = "Z.SGM";
	}

	$filename = $path . $fn;
	
	open(FILE,"$filename");

	
	
	@arr = @_;
	$input = $arr[0];	
	chomp($input);
	$input = uc($input);
	open(FILE,$filename);
	while($line = <FILE>)
	{
	    chomp($line);
	    @tempa = split(/<\/HWD>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<HWD>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    $word = $tempb[1];
		}
	    }
	    @tempa = split(/<\/FIELD>/, $line);
	    if (exists($tempa[0]))
	    {
		@tempb = split(/<FIELD>/, $tempa[0]);
		if (exists($tempb[1]))
		{
		    if ($input eq $tempb[1])
		    {
#			print("$word\n");
			$same_hash{$word}++;
		    }
		}
	    }
	}
	close (FILE);
    }
    return %same_hash;
}




sub same_sub
{
    %same_hash=();

    $word = $_[0];
    @first_alpha = ();

    @first_alpha  = split//,$word;


    $path_name = "/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";     # set the path name
    
    
    $first_alpha[0] = uc($first_alpha[0]);                        # convert the first alphabet into uppercase
    if($first_alpha[0] eq "E")
    {
	$first_alpha[0] = "e";
	$path_name .= $first_alpha[0] . ".sgm";
    }
    
    else
    {
	$path_name .= $first_alpha[0] . ".SGM";
    }

    open(DIC,$path_name);                                         # open the corresponding alphabet file
    
    
    
    open(OUTPUT, "> WORDFILE");                                   # this part reads the file and puts entry of one word in one line
    $line = <DIC>;
    while ($line = <DIC>)
    {
	chomp($line);
	@word = split(/>/,$line);	                          # Split each line with ">" to get <Entry>	
	print(OUTPUT "$line");
	if ($word[$#word-1] eq "</Entry")
	{
	    print(OUTPUT "\n");
	}
    }
    close(OUTPUT);

#    print "\n\nOne more step towards the end !!!";
#    exit();
    
    chomp($word);

    open(FILE,"WORDFILE");

    while($line = <FILE>)
    {
	chomp($line);
#	print "\n$line";
#	<STDIN>;
    
	@tempa = split(/<\/HWD>/, $line);
	if (exists($tempa[0]))
	{
	    @tempb = split(/<HWD>/, $tempa[0]);
	    if (exists($tempb[1]))
	    {
		$head = $tempb[1];
	    }
   
	    if($head)
	    {
		if($head eq $word)
		{
		    print "\n\n$head : $word";	
		    while($line =~ m/<FIELD>(.*?)<\/FIELD>/go)
		    {
			$same_hash{$1}++;
		    }
		}
	    }
	    
	}	
    }
    close (FILE);
    unlink "WORDFILE";
    return %same_hash;    
}






# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

ldoce - direct Perl interface to the Longman's dictionary

=head1 SYNOPSIS
 

=head1 ABSTRACT

  LDOCE is a machine readavle dictionary. This module tries to provide
  interface to access the dictionary

=head1 DESCRIPTION


    Our interface  provides the  user with several  functionalities to
access the data that is present in the LDOCE dictionary.

    To get the information from the database there are several options
    that  can be  used.  For  example if  you want  to get  the entire
    information about a particular word, the function to do that would
    be 

             find_word(word);  

    This would get all the information about the word specified as the
    argument on to the screen.   Other options that have been provided
    with this are :

    getting the Part of Speech:   find_word(word,pos);
    getting   the pronunciation: find_word(word,pron); 
    getting the inflections: find_word(word,inf); 
    getting the  hyphenations:  find_word(word,hyp);
    getting the frequency: find_word(word,freq);

    Other options that can be used with this are: 
    
           sen - for senses 
           tail -for tail

    Another option that has been  provided in this interface is to get
    all the parts of speeches, from the dictionary and also to get all
    the words of a particular part of speech.  To get all the parts of
    speeches in the dictionary:

           all_pos();  
    
    To get  all the  words of  a particular  part  of speech:

           same_pos(part_of_speech);

    where part_of_speech is the part  of speech for which you want the
    words.  The  user will have  to run the all_pos()  function before
    running the same_pos function.

    The user  can also look at  the subject codes that  are present in
    the  dictionary  and  also,   all  the  words  associated  with  a
    particular subject code.  To get all the subject codes:

            sub_codes(); 

    To get all the words associated with a subject code:


            same_subcodes(subcodenum);

    As  with the  part  of speech,  subcodenum  is the  number of  the
    subject code that is assigned by the interface. The user will have
    to run  the sub_codes() function before  running the same_subcodes
    function.


    Lastly, we also provide the user with an option to look at all the
    words  that   have  a  particular  word/words   present  in  their
    definition.The  function similar_def() takes  in a  word/words and
    prints out the words that have these words in their definition.

 
           similar_def(word/words);

    Besides the find_word function the  rest of the functions return a
    hash  that needs to  be captured  by the  user whenever  its being
    plugged into any program.

 
    These are all  the basic functionalities that are  provided by the
    interface.

  


=head2 EXPORT

find_word all_pos similar_def same_pos sub_codes same_subcodes quit_ldoce

=head1 SEE ALSO

bigmac;

WebSearch;

WordNet::QueryData;

=head1 AUTHOR
Sumalatha Kothadi, E<lt>koth0025@d.umn.eduE<gt>
Prashant Jain, E<lt>jain0069@d.umn.eduE<gt>
Nan Zhang, E<lt>zhan0433@d.umn.eduE<gt>
Anand Takale, E<lt>taka0078@d.umn.eduE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by melgarFBC

Members of melgarFBC : Sumalatha Kothadi
                       Prashant Jain
                       Nan Zhang
                       Anand Takale 

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut


