# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl 1.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 21;
BEGIN { use_ok('bigmac') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

require_ok('bigmac');

ok(initialize(),"test2");                                              # sub routine to create the hashes
ok(word_entries("canine"),"test3");                                    #finds the meaning of the word canine in the dicitonary
ok(word_entries("dog","POS"),"test4");                                 #finds the part of speech of the word dog.
ok(word_entries("test","PRON"),"test5");                               #finds the pronunciation of the word test
ok(word_entries("hard"),"test6");                                    #finds the meaning of the word hard in the dicitonary
ok(word_entries("life","POS"),"test7");                                 #finds the part of speech of the word life.
ok(word_entries("term","PRON"),"test8");                               #finds the pronunciation of the word term
ok(all_pos(),"test9");                                                 # to display all parts of speech present in the file
ok(particular_pos("noun"),"test10");                                      # to display all nouns present in the dictionary
ok(particular_pos("verb"),"test11");                                      # to display all verbs in the dictionary
ok(particular_pos("adjective"),"test12");                                      # to display all adjectives in the dictionary
ok(particular_pos("adverb"),"test13");                                      # to display all adverb in the dictionary
ok(particular_pos("phrase"),"test14");                                      # to display all phrases in the dictionary
ok(shared_definition("canine"),"test15");                               #finds all the words that contain canine in their definition
ok(shared_definition("canine","teeth"),"test16");                       #finds all the words that contain canine and teeth in their definition
ok(shared_definition("black"),"test17");                               #finds all the words that contain black in their definition
ok(shared_definition("black","ash"),"test18");                       #finds all the words that contain black and ash in their definition
ok(word_entries("later"),"test19");				     #finds all the information about the word later
ok(word_entries("majority","POS"),"test20");			     #finds all the POS for the word majority
