package WebSearch::WebSearch;

use 5.008;
#use strict;
use warnings;

require Exporter;


our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use WebSearch ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(	) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(qsearch qhits);

our $VERSION = '0.01';


# Preloaded methods go here.

sub qsearch
{
   

use LWP::Simple;                                                                       # Using LWP package 
use HTML::TokeParser;                                                                  # Using HTML parser interface 

$word = "";
$number_of_sentences = 0;
$word = $_[0];

if(exists $_[1])                                                                       # Checking if the user wants a particular number of sentences
{
    $number_of_sentences = $_[1];
}
my $qry =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf"; # construct query from word

#open(OUTFILE,">sentences.txt");




my $content = get($qry);                                                               # get the HTML layout of the webpage in a variable                                           
my %hash = ();
my %has1 = ();
my $i;
my $url;

if (defined $content)
{
    my $try;
    $try = $content;
    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test1 = $';
	my $var;
	my $match;
	$var = $&;
	my @temparr = split/ /,$var;
	$match = $temparr[2];
	$match =~ s/,//g;
	$test = $test1;
	$test =~ m/Add your Web site\'s pages to AltaVista search results with/;
	if(defined $&)
	{
	    $content = $`;
 	    #$content will contain the html associated with the url mentioned
	    my $stream = HTML::TokeParser->new(\$content);
	    while (my $token = $stream->get_tag("a"))                                     # loop to extract all links from HTML document
	    {                                                                             # reference : http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html

		my $url = $token->[1]{href} || "-";
		$hash{$url}++;
	    }                                                                             # end of reference
	}
	if($match > 10)                                                               # to check if there are more than 10 matches
	{
	    $i = 10;
	    my $pgcnt = int($match/10);
	    $pgcnt = $pgcnt + 1;
	    my $ctr = 1;
	    while($ctr <= $pgcnt && $ctr <= 1)                                      # scans through rest of the search pages of Altavista
	    {
         	$url = "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf&stq=" . $i;
		$content = get($url);
		$i += 10;
		if(defined $content)
		{
		    $try = $content;
		    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
		    if(defined $&)
		    {
			$test1 = $';
			$test = $test1;
			$test =~ m/Add your Web site\'s pages to AltaVista search results with/;
			if(defined $&)
			{
			    $content = $`;
			    #$content will contain the html associated with the url mentioned
			    $stream = HTML::TokeParser->new(\$content);
			    my $token;
			    while ($token = $stream->get_tag("a"))                            # extracts all links from HTML document 
			    {                                                                 # reference http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html
				$url = $token->[1]{href} || "-";
				$hash{$url}++;
			    }                                                                 # end of reference
			}
		    }
		}
		$ctr++;
	    }
	}
    }
    else
    {
	print "No matches were found for the word.\n";
    }
}



else
{
    #If an error occurs then $content will not be defined.
    print "Error: Get failed";
}

#print "Done With getting urls....\n\n";

my $complete = "";

foreach $url(keys %hash)
{
    $url =~ m/www(.)*/;                                                            # searching through all documents whose links are stored in the hash
    if (defined $&)
    {
	$url = $&;
	$url =~ s/%2F/\//g;
	$url =~ s/&language\=en//g;
	$url =~ s/%.*$//;
	$url = "http://" . $url;
	$hash1{$url}++;
#	print "URL: $url\n\n\n\n";
    }
}

#print "Done with cleaning up urls....\n\n";

foreach $url(keys %hash1)
{
     $newcontent = get($url);
    if(defined $newcontent)
    {
#	print "GOTTEN URL: $url\n\n\n\n";
	$newcontent =~ s/<[^>]+>//g;
	$newcontent =~ s/\s+/ /g;
	$newcontent =~ s/\&.*?\;//g;
	$newcontent =~ s/[^A-Za-z0-9 \.]//g;
#	print "$newcontent\n\n\n";
	$complete .= $newcontent;                                               # concatenating all the data to one variable
     }
}

#print "Done with getting everything in one loooooooooooooooooooooooooooonnnng variable\n";


my @seperate_lines = ();  

@seperate_lines = split/[\.\?!]/,$complete;                                       # splitting sentences

my $reg_exp = "";

$reg_exp .= "[";

my @seperated_word = ();

@seperated_word = split//,$word;

$reg_exp .= $seperated_word[0];

$reg_exp .= uc($seperated_word[0]);

$reg_exp .= "]";

for($i=1;$i<=$#seperated_word;$i++)
{
    $reg_exp .= $seperated_word[$i];
}

my %sentence_hash = ();

$sent_count = 0;
for($i=0;$i<=$#seperate_lines;$i++)                                             # comparing sentences to see if the word required by user is present
{
    my $temp;
    $temp = $seperate_lines[$i];
    $temp =~ m/$reg_exp/;
    if($number_of_sentences > 0)
    {
	if($& and $sent_count <= $number_of_sentences)
	{
	    
	    $temp =~ s/\/s+/ /g;
	    $temp =~ s/[^A-Za-z0-9 ]//g;
	    $sentence_hash{$temp}++;
	    if($sentence_hash{$temp} == 1)
	    {
		$sent_count++;
	    }
	}
    }
    else
    {
	$temp =~ s/\/s+/ /g;
	$temp =~ s/[^A-Za-z0-9 ]//g;
	$sentence_hash{$temp}++;	
    }
}

return %sentence_hash;
}


sub qhits
{
   

use LWP::Simple;                                                                       # Using LWP package 
use HTML::TokeParser;                                                                  # Using HTML parser interface 

$word = "";
$number_of_sentences = 0;
$word = "excellent+NEAR+";
$word1 = "poor+NEAR+";
$word2 = "excellent";
$word3 = "poor";
$word .= $_[0];
$word1 .= $_[0];

if(exists $_[1])                                                                       # Checking if the user wants a particular number of sentences
{
    $number_of_sentences = $_[1];
}
my $qry =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf"; # construct query from word
my $qry1 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word1."&avkw=rf"; # construct query from word
my $qry2 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word2."&avkw=rf"; # construct query from word
my $qry3 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word3."&avkw=rf"; # construct query from word


#open(OUTFILE,">sentences.txt");




my $content = get($qry); 
my $content1 = get($qry1);                                                              # get the HTML layout of the webpage in a variable                                      my $content2 = get($qry2);
my $content3 = get($qry3);

my %hash = ();
my %has1 = ();
my $i;
my $url;
my @returnarr = ();
if (defined $content)
{
    my $try;
    $try = $content;
    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test1 = $';
	my $var;
	my $match;
	$var = $&;
	my @temparr = split/ /,$var;
	$match = $temparr[2];
	$match =~ s/,//g;
	$returnarr[0] = $match;    
    }
}

if (defined $content1)
{
    my $try1;
    $try1 = $content1;
    $try1 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test2 = $';
	my $var1;
	my $match1;
	$var1 = $&;
	my @temparr1 = split/ /,$var1;
	$match1 = $temparr1[2];
	$match1 =~ s/,//g;
  	$returnarr[1] = $match1;
    }
}

if (defined $content2)
{
    my $try2;
    $try2 = $content2;
    $try2 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test3 = $';
	my $var2;
	my $match2;
	$var2 = $&;
	my @temparr2 = split/ /,$var2;
	$match2 = $temparr2[2];
	$match2 =~ s/,//g;
  	$returnarr[2] = $match2;
    }
}

if (defined $content3)
{
    my $try3;
    $try3 = $content3;
    $try3 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test3 = $';
	my $var3;
	my $match3;
	$var3 = $&;
	my @temparr3 = split/ /,$var3;
	$match3 = $temparr3[2];
	$match3 =~ s/,//g;
  	$returnarr[3] = $match3;
    }
}


return @returnarr;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

WebSearch - Perl extension for querying Web through AltaVista search engine

=head1 SYNOPSIS

  use WebSearch;
  qsearch();

  The module will prompt the user to enter a word which will be queried using the altavista search engine
  Choice will be given to the user whether he wants the output to a file or to Standard Output   

=head1 ABSTRACT

  The WebSearch::WebSearch is a module which can be used to gather data from the web. The module prompts the user 
  to enter a word which is then used to query the web through Altavista search engine. The WebSearch module
  runs only for a single word as of now. It can be converted to accept input of more than one words. As of now
  the module queries Altavista search engine and scans through all the pages and all the links that appear
  on the pages.

=head1 DESCRIPTION

  The WebSearch module returns all the sentences containing the word entered by the user.It outputs 
  the sentences either to standard output or to file according to the choice of user.

  To start using the module you can write a simple test program as follows

----------------------------------
  #! /usr/local/bin/perl
  #use WebSearch;
  #qsearch();  
---------------------------------

**********************************************************************************************************
For coding of the programs the following resources were referred

Altavista.com --> to query the web

http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html --> to extract all the links from HTML document

Perl & LWp - O-Reilly Publications --> for usage of LWP package
*********************************************************************************************************

=head2 EXPORT

  none.



=head1 SEE ALSO

    LWP::Simple();

=head1 AUTHOR

Nan Zhang E<lt>zhan0433@d.umn.eduE<gt>
Sumalatha Kothadi E<lt>koth0025@d.umn.eduE<gt>
Prashant Jain, E<lt>jain0069@d.umn.eduE<gt>
Anand Takale, E<lt>taka0078@d.umn.eduE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by melgarFBC

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut



